import {world, system, EquipmentSlot, ItemStack, EntityEquippableComponent} from "@minecraft/server";

const light15 = ["lit_pumpkin", "lava_bucket", "glowstone", "shroomlight", "beacon", "lantern", "sea_lantern", "campfire", "froglight", "end_rod"]
const light13 = ["torch_offhand", "minecraft:torch", "soul_lantern", "soul_campfire", "candle"]
const light11 = ["crying_obsidian", "soul_torch", "soul_torch_offhand"]
const light9 = ["fire_charge", "redstone_torch", "redstone_torch_offhand", "ender_chest", "enchanting_table", "catalyst", "totem_of_undying", "nether_star"]
const light6 = ["enchanted_book", "dragon_breath", "ender_eye", "magma", "blaze_rod", "blaze_powder", "glow_ink_sac", "glow_berries", "glowstone_dust", "experience_bottle"]
const light_offhand = ["new:soul_torch_offhand", "new:redstone_torch_offhand", "new:torch_offhand", , "totem_of_undying"]
const light_all = ["lit_pumpkin", "lava_bucket", "glowstone", "shroomlight", "beacon", "lantern", "sea_lantern", "campfire", "froglight","torch_offhand", "minecraft:torch", "soul_lantern", "soul_campfire", "candle","crying_obsidian", "soul_torch", "soul_torch_offhand", "catalyst", "redstone_torch", "redstone_torch_offhand", "ender_chest", "enchanting_table", "magma", "blaze_rod", "blaze_powder", "glow_ink_sac", "glow_berries", "glowstone_dust"]


system.runInterval( () =>{
  for(const p of world.getPlayers()){
    const equip = p.getComponent(EntityEquippableComponent.componentId);
    const hand = equip.getEquipment(EquipmentSlot.Mainhand);
    const offhand = equip.getEquipment(EquipmentSlot.Offhand);
    const inv = p.getComponent("inventory").container;
    for(let slot = 0; slot < inv.size; slot++){
      const item = inv.getItem(slot);
      if(item){
        const lore = item.getLore()[0];
        for(const types of light15){
          if(item.typeId.includes(`${types}`)){
            if(item.typeId != "minecraft:glowstone_dust"){
              if(!lore){
                item.setLore([`§6Lightning: §715 Blocks`, `\n§r§d[System Dynamic Lights]§r`])
                inv.setItem(slot, item)
              }
            }
          }
        }
        for(const types of light13){
          if(item.typeId.includes(`${types}`)){
            if(!lore){
              if(!item.typeId.includes("sea_pickle")){
                item.setLore([`§6Lightning: §713 Blocks`, `\n§r§d[System Dynamic Lights]§r`])
                inv.setItem(slot, item)
              }
            }
          }
        }
        if(!lore){
          if(item.typeId.includes("sea_pickle")){
            item.setLore([`§6Lightning: §713 Blocks`, "You can use it underwater", `\n§r§d[System Dynamic Lights]§r`])
            inv.setItem(slot, item)
          }
        }
        for(const types of light9){
          if(item.typeId.includes(`${types}`)){
            if(!lore){
              item.setLore([`§6Lightning: §79 Blocks`, `\n§r§d[System Dynamic Lights]§r`])
              inv.setItem(slot, item)
            }
          }
        }
        for(const types of light11){
          if(item.typeId.includes(`${types}`)){
            if(!lore){
              item.setLore([`§6Lightning: §711 Blocks`, `\n§r§d[System Dynamic Lights]§r`])
              inv.setItem(slot, item)
            }
          }
        }
        for(const types of light6){
          if(item.typeId.includes(`${types}`)){
            if(!lore){
              item.setLore([`§6Lightning: §76 Blocks`, `\n§r§d[System Dynamic Lights]§r`])
              inv.setItem(slot, item)
            }
          }
        }
      }
    }

    for(const offlight of light_offhand){
      if(p.hasTag("offhand") && !p.hasTag("mainhand")){
        p.removeTag("offhand")
        p.runCommandAsync(`execute as @s[hasitem={item=${offlight},location=slot.weapon.offhand,quantity=0}] run function no_light`);
      }
    }
    for(const light of light_all){
      if(p.hasTag("mainhand") && !p.hasTag("offhand")){
        p.removeTag("mainhand")
        p.runCommandAsync(`execute as @s[hasitem={item=${light},location=slot.weapon.mainhand,quantity=0}] run function no_light`);
      }
    }
    if(offhand){
      if(offhand.typeId.includes("new:torch_offhand")||offhand.typeId.includes("new:sea_pickle_offhand")){
        p.addTag("offhand")
        p.runCommandAsync(`execute as @s positioned ~~1~ run function light13`);
      }
      if(offhand.typeId.includes("new:sea_pickle_offhand")){
        p.addTag("offhand")
        p.runCommandAsync(`execute as @s positioned ~~1~ run function sea_pickle`);
      }
      if(offhand.typeId.includes("soul_torch_offhand")){
        p.addTag("offhand")
        p.runCommandAsync(`execute as @s positioned ~~1~ run function light11`);
      }
      if(offhand.typeId.includes("redstone_torch_offhand")){
        p.addTag("offhand")
        p.runCommandAsync(`execute as @s positioned ~~1~ run function light9`);
      }
      if(offhand.typeId.includes("totem_of_undying")){
        p.addTag("offhand")
        p.runCommandAsync(`execute as @s positioned ~~1~ run function light9`);
      }
    }

    if(hand && !p.hasTag("offhand")){
      for(const l13 of light13){
        if(hand.typeId.includes(l13)){
          p.addTag("mainhand")
          p.runCommandAsync(`execute as @s positioned ~~1~ run function light13`);
        }
      }
      if(hand.typeId.includes("sea_pickle")){
        p.addTag("mainhand")
        p.runCommandAsync(`execute as @s positioned ~~1~ run function sea_pickle`);
      }
      for(const l11 of light11){
        if(hand.typeId.includes(l11)){
          p.addTag("mainhand")
          p.runCommandAsync(`execute as @s positioned ~~1~ run function light11`);
        }
      }
      for(const l9 of light9){
        if(hand.typeId.includes(l9)){
          p.addTag("mainhand")
          p.runCommandAsync(`execute as @s positioned ~~1~ run function light9`);
        }
      }
      for(const l15 of light15){
        if(hand.typeId.includes(l15)){
          if(hand.typeId != "minecraft:glowstone_dust"){
            p.addTag("mainhand")
            p.runCommandAsync(`execute as @s positioned ~~1~ run function light15`);
          }
        }
      }
      for(const l6 of light6){
        if(hand.typeId.includes(l6)){
          p.addTag("mainhand")
          p.runCommandAsync(`execute as @s positioned ~~1~ run function light6`);
        }
      }
    }
  } 
})

const offhand_items = ["soul_torch", "redstone_torch", "torch", "sea_pickle"]
world.afterEvents.itemUse.subscribe(use=>{
  const item = use.itemStack;
  const p = use.source;
  const equip = p.getComponent(EntityEquippableComponent.componentId);
  const offhand = equip.getEquipment(EquipmentSlot.Offhand);
  offhand_items.forEach(o=>{
    if(item.typeId==`minecraft:${o}`&&!offhand){
      const change_item = new ItemStack(`new:${o}_offhand`, item.amount)
      equip.setEquipment(EquipmentSlot.Offhand, change_item)
      equip.setEquipment(EquipmentSlot.Mainhand, undefined)
    }
    if(item.typeId==`new:${o}_offhand`&&!offhand){
      equip.setEquipment(EquipmentSlot.Offhand, item)
      equip.setEquipment(EquipmentSlot.Mainhand, undefined)
    }
  })
  if(item.typeId.includes("totem_of_undying")&&!offhand){
    equip.setEquipment(EquipmentSlot.Offhand, item)
    equip.setEquipment(EquipmentSlot.Mainhand, undefined)
  }
})